Index: branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Calendar/3.3/HeuristicLab.Calendar-3.3.csproj
===================================================================
--- branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Calendar/3.3/HeuristicLab.Calendar-3.3.csproj	(revision 4343)
+++ branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Calendar/3.3/HeuristicLab.Calendar-3.3.csproj	(revision 4368)
@@ -53,4 +53,5 @@
     <WarningLevel>4</WarningLevel>
     <CodeAnalysisRuleSet>AllRules.ruleset</CodeAnalysisRuleSet>
+    <PlatformTarget>AnyCPU</PlatformTarget>
   </PropertyGroup>
   <PropertyGroup Condition=" '$(Configuration)|$(Platform)' == 'Release|AnyCPU' ">
@@ -70,4 +71,12 @@
     <PlatformTarget>x86</PlatformTarget>
     <OutputPath>bin\x86\Release\</OutputPath>
+  </PropertyGroup>
+  <PropertyGroup Condition="'$(Configuration)|$(Platform)' == 'Debug|x64'">
+    <PlatformTarget>x64</PlatformTarget>
+    <OutputPath>bin\x64\Debug\</OutputPath>
+  </PropertyGroup>
+  <PropertyGroup Condition="'$(Configuration)|$(Platform)' == 'Release|x64'">
+    <PlatformTarget>x64</PlatformTarget>
+    <OutputPath>bin\x64\Release\</OutputPath>
   </PropertyGroup>
   <ItemGroup>
Index: branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Calendar/3.3/Properties/AssemblyInfo.cs
===================================================================
--- branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Calendar/3.3/Properties/AssemblyInfo.cs	(revision 4343)
+++ branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Calendar/3.3/Properties/AssemblyInfo.cs	(revision 4368)
@@ -58,3 +58,3 @@
 // [assembly: AssemblyVersion("1.0.*")]
 [assembly: AssemblyVersion("3.3.0.0")]
-[assembly: AssemblyFileVersion("3.3.0.4342")]
+[assembly: AssemblyFileVersion("3.3.0.4343")]
Index: branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive 3.3.sln
===================================================================
--- branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive 3.3.sln	(revision 4343)
+++ branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive 3.3.sln	(revision 4368)
@@ -31,4 +31,6 @@
 		HeuristicLab 3.3.vsmdi = HeuristicLab 3.3.vsmdi
 		LocalTestRun.testrunconfig = LocalTestRun.testrunconfig
+		Performance1.psess = Performance1.psess
+		Performance3.psess = Performance3.psess
 		PreBuildEvent.cmd = PreBuildEvent.cmd
 	EndProjectSection
@@ -117,5 +119,6 @@
 		{C92AAC8C-4D88-449C-ABA5-2B935D769842}.Debug|Mixed Platforms.ActiveCfg = Debug|Any CPU
 		{C92AAC8C-4D88-449C-ABA5-2B935D769842}.Debug|Mixed Platforms.Build.0 = Debug|Any CPU
-		{C92AAC8C-4D88-449C-ABA5-2B935D769842}.Debug|x64.ActiveCfg = Debug|Any CPU
+		{C92AAC8C-4D88-449C-ABA5-2B935D769842}.Debug|x64.ActiveCfg = Debug|x64
+		{C92AAC8C-4D88-449C-ABA5-2B935D769842}.Debug|x64.Build.0 = Debug|x64
 		{C92AAC8C-4D88-449C-ABA5-2B935D769842}.Debug|x86.ActiveCfg = Debug|x86
 		{C92AAC8C-4D88-449C-ABA5-2B935D769842}.Debug|x86.Build.0 = Debug|x86
@@ -256,5 +259,6 @@
 		{D17A4D6A-4CAA-4470-8A19-F42463C021FD}.Debug|Mixed Platforms.ActiveCfg = Debug|Any CPU
 		{D17A4D6A-4CAA-4470-8A19-F42463C021FD}.Debug|Mixed Platforms.Build.0 = Debug|Any CPU
-		{D17A4D6A-4CAA-4470-8A19-F42463C021FD}.Debug|x64.ActiveCfg = Debug|Any CPU
+		{D17A4D6A-4CAA-4470-8A19-F42463C021FD}.Debug|x64.ActiveCfg = Debug|x64
+		{D17A4D6A-4CAA-4470-8A19-F42463C021FD}.Debug|x64.Build.0 = Debug|x64
 		{D17A4D6A-4CAA-4470-8A19-F42463C021FD}.Debug|x86.ActiveCfg = Debug|x86
 		{D17A4D6A-4CAA-4470-8A19-F42463C021FD}.Debug|x86.Build.0 = Debug|x86
@@ -269,5 +273,6 @@
 		{A84C0A25-13D0-40A6-924F-53556D9691DC}.Debug|Mixed Platforms.ActiveCfg = Debug|x86
 		{A84C0A25-13D0-40A6-924F-53556D9691DC}.Debug|Mixed Platforms.Build.0 = Debug|x86
-		{A84C0A25-13D0-40A6-924F-53556D9691DC}.Debug|x64.ActiveCfg = Debug|x86
+		{A84C0A25-13D0-40A6-924F-53556D9691DC}.Debug|x64.ActiveCfg = Debug|x64
+		{A84C0A25-13D0-40A6-924F-53556D9691DC}.Debug|x64.Build.0 = Debug|x64
 		{A84C0A25-13D0-40A6-924F-53556D9691DC}.Debug|x86.ActiveCfg = Debug|x86
 		{A84C0A25-13D0-40A6-924F-53556D9691DC}.Debug|x86.Build.0 = Debug|x86
@@ -282,5 +287,6 @@
 		{4F15BEA2-F494-4584-A0E5-6BA85377B313}.Debug|Mixed Platforms.ActiveCfg = Debug|x86
 		{4F15BEA2-F494-4584-A0E5-6BA85377B313}.Debug|Mixed Platforms.Build.0 = Debug|x86
-		{4F15BEA2-F494-4584-A0E5-6BA85377B313}.Debug|x64.ActiveCfg = Debug|x86
+		{4F15BEA2-F494-4584-A0E5-6BA85377B313}.Debug|x64.ActiveCfg = Debug|x64
+		{4F15BEA2-F494-4584-A0E5-6BA85377B313}.Debug|x64.Build.0 = Debug|x64
 		{4F15BEA2-F494-4584-A0E5-6BA85377B313}.Debug|x86.ActiveCfg = Debug|x86
 		{4F15BEA2-F494-4584-A0E5-6BA85377B313}.Debug|x86.Build.0 = Debug|x86
@@ -295,6 +301,8 @@
 		{CDAD2510-299C-4FA2-B351-9D71A5AF20B7}.Debug|Mixed Platforms.ActiveCfg = Debug|Any CPU
 		{CDAD2510-299C-4FA2-B351-9D71A5AF20B7}.Debug|Mixed Platforms.Build.0 = Debug|Any CPU
-		{CDAD2510-299C-4FA2-B351-9D71A5AF20B7}.Debug|x64.ActiveCfg = Debug|Any CPU
-		{CDAD2510-299C-4FA2-B351-9D71A5AF20B7}.Debug|x86.ActiveCfg = Debug|Any CPU
+		{CDAD2510-299C-4FA2-B351-9D71A5AF20B7}.Debug|x64.ActiveCfg = Debug|x64
+		{CDAD2510-299C-4FA2-B351-9D71A5AF20B7}.Debug|x64.Build.0 = Debug|x64
+		{CDAD2510-299C-4FA2-B351-9D71A5AF20B7}.Debug|x86.ActiveCfg = Debug|x86
+		{CDAD2510-299C-4FA2-B351-9D71A5AF20B7}.Debug|x86.Build.0 = Debug|x86
 		{CDAD2510-299C-4FA2-B351-9D71A5AF20B7}.Release|Any CPU.ActiveCfg = Release|Any CPU
 		{CDAD2510-299C-4FA2-B351-9D71A5AF20B7}.Release|Any CPU.Build.0 = Release|Any CPU
Index: branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Contracts/3.3/BusinessObjects/HivePluginInfoDto.cs
===================================================================
--- branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Contracts/3.3/BusinessObjects/HivePluginInfoDto.cs	(revision 4343)
+++ branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Contracts/3.3/BusinessObjects/HivePluginInfoDto.cs	(revision 4368)
@@ -28,4 +28,5 @@
 using HeuristicLab.PluginInfrastructure;
 using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HeuristicLab.Hive.JobBase;
 
 namespace HeuristicLab.Hive.Contracts.BusinessObjects {
@@ -71,4 +72,12 @@
     }
 
+    public static List<HivePluginInfoDto> FindPluginsNeeded(Type type) {
+      return (
+        from p in PluginUtil.GetDeclaringPlugins(type)
+        select new HivePluginInfoDto() {
+          Name = p.Name,
+          Version = p.Version
+        }).ToList();
+    }
   }
 }
Index: branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Contracts/3.3/BusinessObjects/JobDto.cs
===================================================================
--- branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Contracts/3.3/BusinessObjects/JobDto.cs	(revision 4343)
+++ branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Contracts/3.3/BusinessObjects/JobDto.cs	(revision 4368)
@@ -41,5 +41,5 @@
     [Storable]
     [DataMember]
-    public string UserId { get; set; }
+    public Guid? UserId { get; set; }
     [Storable]
     [DataMember]
Index: branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Contracts/3.3/BusinessObjects/JobResult.cs
===================================================================
--- branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Contracts/3.3/BusinessObjects/JobResult.cs	(revision 4343)
+++ branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Contracts/3.3/BusinessObjects/JobResult.cs	(revision 4368)
@@ -38,7 +38,4 @@
     [Storable]
     [DataMember]
-    public Guid JobId { get; set; }
-    [Storable]
-    [DataMember]
     public Guid SlaveId { get; set; }
     [Storable]
@@ -53,18 +50,25 @@
     [Storable]
     [DataMember]
+    public DateTime? DateCreated { get; set; }
+    [Storable]
+    [DataMember]
     public DateTime? DateCalculated { get; set; }
     [Storable]
     [DataMember]
     public DateTime? DateFinished { get; set; }
+    [Storable]
+    [DataMember]
+    public Guid? ParentJobId { get; set; }
 
     public override Common.IDeepCloneable Clone(Common.Cloner cloner) {
       JobResult clone = (JobResult) base.Clone(cloner);
       clone.SlaveId = this.SlaveId;
+      clone.DateCreated = this.DateCreated;
       clone.DateCalculated = this.DateCalculated;
       clone.DateFinished = this.DateFinished;
       clone.Exception = this.Exception;
-      clone.JobId = this.JobId;
       clone.Percentage = this.Percentage;
       clone.State = this.State;
+      clone.ParentJobId = this.ParentJobId;
       return clone;
     }
Index: branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Contracts/3.3/BusinessObjects/JobState.cs
===================================================================
--- branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Contracts/3.3/BusinessObjects/JobState.cs	(revision 4343)
+++ branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Contracts/3.3/BusinessObjects/JobState.cs	(revision 4368)
@@ -13,5 +13,6 @@
     SnapshotSent,
     Pending,
-    Failed
+    Failed,
+    WaitForChildJobs
   };
 }
Index: branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Contracts/3.3/BusinessObjects/SerializedJobList.cs
===================================================================
--- branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Contracts/3.3/BusinessObjects/SerializedJobList.cs	(revision 4368)
+++ branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Contracts/3.3/BusinessObjects/SerializedJobList.cs	(revision 4368)
@@ -0,0 +1,54 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using System.Runtime.Serialization;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HeuristicLab.Common;
+using HeuristicLab.Collections;
+
+namespace HeuristicLab.Hive.Contracts.BusinessObjects {
+  [StorableClass]
+  [Serializable]
+  public class SerializedJobList : ObservableList<SerializedJob>, IDeepCloneable {
+    public SerializedJobList() { }
+    public SerializedJobList(IEnumerable<SerializedJob> collection) {
+      this.list = new List<SerializedJob>(collection);
+    }
+
+    [StorableConstructor]
+    protected SerializedJobList(bool deserializing) : base(deserializing) { }
+
+    public object Clone() {
+      return Clone(new Cloner());
+    }
+
+    public virtual IDeepCloneable Clone(Cloner cloner) {
+      SerializedJobList clone = (SerializedJobList)Activator.CreateInstance(this.GetType());
+      cloner.RegisterClonedObject(this, clone);
+      clone.list = (this.Select(x => (SerializedJob)cloner.Clone(x))).ToList();
+      return clone;
+    }
+  }
+}
Index: branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Contracts/3.3/Disposable.cs
===================================================================
--- branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Contracts/3.3/Disposable.cs	(revision 4368)
+++ branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Contracts/3.3/Disposable.cs	(revision 4368)
@@ -0,0 +1,21 @@
+﻿using System;
+
+namespace HeuristicLab.Hive.Contracts {
+  public class Disposable<T> : IDisposable {
+    private T obj;
+    public T Obj {
+      get { return obj; }
+    }
+
+    public Disposable(T obj) {
+      this.obj = obj;
+    }
+
+    public void Dispose() {
+      if (OnDisposing != null)
+        OnDisposing(this, new EventArgs());
+    }
+
+    public event EventHandler OnDisposing;
+  }
+}
Index: branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Contracts/3.3/HeuristicLab.Hive.Contracts-3.3.csproj
===================================================================
--- branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Contracts/3.3/HeuristicLab.Hive.Contracts-3.3.csproj	(revision 4343)
+++ branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Contracts/3.3/HeuristicLab.Hive.Contracts-3.3.csproj	(revision 4368)
@@ -119,4 +119,5 @@
     <Compile Include="BusinessObjects\CachedHivePluginInfoDto.cs" />
     <Compile Include="BusinessObjects\CalendarState.cs" />
+    <Compile Include="BusinessObjects\SerializedJobList.cs" />
     <Compile Include="BusinessObjects\SlaveGroupDto.cs" />
     <Compile Include="BusinessObjects\HivePluginFile.cs" />
@@ -130,5 +131,4 @@
     <Compile Include="BusinessObjects\JobDto.cs" />
     <Compile Include="BusinessObjects\JobResult.cs" />
-    <Compile Include="BusinessObjects\SerializedJobResult.cs" />
     <Compile Include="BusinessObjects\SlaveState.cs" />
     <Compile Include="BusinessObjects\UpTimeStatisticsDto.cs" />
@@ -136,4 +136,7 @@
     <Compile Include="BusinessObjects\SlaveConfigDto.cs" />
     <Compile Include="BusinessObjects\SlaveGroupDtoList.cs" />
+    <Compile Include="Disposable.cs" />
+    <Compile Include="MessageContainerWithCallback.cs" />
+    <Compile Include="MessageContainerWithJob.cs" />
     <Compile Include="RecurrentEvent.cs" />
     <Compile Include="ResponseObjects\ResponseCalendar.cs" />
@@ -157,4 +160,6 @@
     <Compile Include="HiveRoles.cs" />
     <Compile Include="StreamedObject.cs" />
+    <Compile Include="WcfServicePool.cs" />
+    <Compile Include="WcfServicePoolException.cs" />
     <Compile Include="WcfSettings.cs" />
   </ItemGroup>
@@ -167,4 +172,8 @@
       <Project>{9076697B-C151-46CD-95BC-1D059492B478}</Project>
       <Name>HeuristicLab.DataAccess-3.3</Name>
+    </ProjectReference>
+    <ProjectReference Include="..\..\HeuristicLab.Hive.JobBase\3.3\HeuristicLab.Hive.JobBase-3.3.csproj">
+      <Project>{21187322-52DD-4243-80A4-A85F0263E63B}</Project>
+      <Name>HeuristicLab.Hive.JobBase-3.3</Name>
     </ProjectReference>
   </ItemGroup>
Index: branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Contracts/3.3/Interfaces/IClientFacade.cs
===================================================================
--- branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Contracts/3.3/Interfaces/IClientFacade.cs	(revision 4343)
+++ branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Contracts/3.3/Interfaces/IClientFacade.cs	(revision 4368)
@@ -38,5 +38,7 @@
     Response RequestSnapshot(Guid jobId);
     [OperationContract]
-    ResponseObject<SerializedJob> GetLastSerializedResult(Guid jobId, bool requested, bool snapshot);
+    ResponseObject<SerializedJob> GetLastSerializedResult(Guid jobId);
+    [OperationContract]
+    ResponseObject<SerializedJob> GetSnapshotResult(Guid jobId);
     [OperationContract]
     Response AbortJob(Guid jobId);
@@ -45,4 +47,6 @@
     [OperationContract]
     ResponseObject<JobResultList> GetJobResults(IEnumerable<Guid> jobIds);
+    [OperationContract]
+    ResponseObject<JobResultList> GetChildJobResults(Guid? parentJobId, bool recursive, bool includeParent);
   }
 }
Index: branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Contracts/3.3/Interfaces/IJobManager.cs
===================================================================
--- branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Contracts/3.3/Interfaces/IJobManager.cs	(revision 4343)
+++ branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Contracts/3.3/Interfaces/IJobManager.cs	(revision 4368)
@@ -57,5 +57,8 @@
 
     [OperationContract]
-    ResponseObject<SerializedJob> GetLastSerializedResult(Guid jobId, bool requested, bool snapshot);
+    ResponseObject<SerializedJob> GetLastSerializedResult(Guid jobId);
+
+    [OperationContract]
+    ResponseObject<SerializedJob> GetSnapshotResult(Guid jobId);
 
     [OperationContract]
@@ -85,4 +88,13 @@
     [OperationContract]
     ResponseObject<JobDto> AddJobWithGroupStrings(SerializedJob job, IEnumerable<string> resources);
+
+    [OperationContract]
+    ResponseObject<JobResultList> GetChildJobResults(Guid? parentJobId, bool recursive, bool includeParent);
+
+    [OperationContract]
+    ResponseObject<JobDto> AddChildJob(Guid parentJobId, SerializedJob serializedJob);
+
+    [OperationContract]
+    ResponseObject<JobDto> PauseJob(SerializedJob serializedJob);
   }
 }
Index: branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Contracts/3.3/Interfaces/ISlaveCommunicator.cs
===================================================================
--- branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Contracts/3.3/Interfaces/ISlaveCommunicator.cs	(revision 4343)
+++ branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Contracts/3.3/Interfaces/ISlaveCommunicator.cs	(revision 4368)
@@ -28,4 +28,5 @@
 using HeuristicLab.PluginInfrastructure;
 using HeuristicLab.Hive.Contracts.ResponseObjects;
+using HeuristicLab.Hive.JobBase;
 
 namespace HeuristicLab.Hive.Contracts.Interfaces {
@@ -68,5 +69,4 @@
     [OperationContract]
     Response SetCalendarStatus(Guid clientId, CalendarState state);
-
   }
 }
Index: branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Contracts/3.3/Interfaces/ISlaveFacade.cs
===================================================================
--- branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Contracts/3.3/Interfaces/ISlaveFacade.cs	(revision 4343)
+++ branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Contracts/3.3/Interfaces/ISlaveFacade.cs	(revision 4368)
@@ -28,4 +28,5 @@
 using HeuristicLab.Hive.Contracts.BusinessObjects;
 using HeuristicLab.Hive.Contracts.ResponseObjects;
+using HeuristicLab.Hive.JobBase;
 
 namespace HeuristicLab.Hive.Contracts.Interfaces {
@@ -43,4 +44,16 @@
     [OperationContract]
     ResponseResultReceived ProcessSnapshotStreamed(Stream stream);
+
+    [OperationContract]
+    ResponseObject<JobDto> AddChildJob(Guid parentJobId, SerializedJob serializedJob);
+
+    [OperationContract]
+    ResponseObject<JobDto> PauseJob(SerializedJob serializedJob);
+
+    [OperationContract]
+    JobResultList GetChildJobResults(Guid? parentJobId, bool recursive, bool includeParent);
+
+    [OperationContract]
+    SerializedJob GetLastSerializedResult(Guid jobId);
   }
 }
Index: branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Contracts/3.3/MessageContainer.cs
===================================================================
--- branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Contracts/3.3/MessageContainer.cs	(revision 4343)
+++ branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Contracts/3.3/MessageContainer.cs	(revision 4368)
@@ -36,6 +36,9 @@
   public class MessageContainer : IDeepCloneable {
 
-    public enum MessageType { FetchJob, AbortJob, JobAborted, RequestSnapshot, FinishedJob, NoMessage, SnapshotReady, Shutdown, JobFailed, UptimeLimitDisconnect,
-      FetchOrForceFetchCalendar
+    public enum MessageType {
+      FetchJob, AbortJob, JobAborted, RequestSnapshot, FinishedJob, NoMessage, SnapshotReady, Shutdown, JobFailed, UptimeLimitDisconnect,
+      FetchOrForceFetchCalendar, AddChildJob,
+      PauseJob,
+      GetChildJobs
     };
 
Index: branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Contracts/3.3/MessageContainerWithCallback.cs
===================================================================
--- branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Contracts/3.3/MessageContainerWithCallback.cs	(revision 4368)
+++ branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Contracts/3.3/MessageContainerWithCallback.cs	(revision 4368)
@@ -0,0 +1,26 @@
+﻿using System;
+using HeuristicLab.Common;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HeuristicLab.Hive.JobBase;
+using System.Collections.Generic;
+
+namespace HeuristicLab.Hive.Contracts {
+  [StorableClass]
+  [Serializable]
+  public class MessageContainerWithCallback<CallbackParameterType> : MessageContainer {
+
+    [Storable]
+    public Action<CallbackParameterType> Callback;
+
+    public MessageContainerWithCallback(MessageType message, Guid parentJobId, Action<CallbackParameterType> callback)
+      : base(message, parentJobId) {
+        this.Callback = callback;
+    }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      MessageContainerWithJob clone = (MessageContainerWithJob)base.Clone(cloner);
+
+      return clone;
+    }
+  }
+}
Index: branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Contracts/3.3/MessageContainerWithJob.cs
===================================================================
--- branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Contracts/3.3/MessageContainerWithJob.cs	(revision 4368)
+++ branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Contracts/3.3/MessageContainerWithJob.cs	(revision 4368)
@@ -0,0 +1,51 @@
+﻿#region License Information
+/* HeuristicLab
+ * Copyright (C) 2002-2008 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
+ *
+ * This file is part of HeuristicLab.
+ *
+ * HeuristicLab is free software: you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License as published by
+ * the Free Software Foundation, either version 3 of the License, or
+ * (at your option) any later version.
+ *
+ * HeuristicLab is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
+ */
+#endregion
+
+using System;
+using System.Collections.Generic;
+using System.Linq;
+using System.Text;
+using HeuristicLab.Persistence.Default.CompositeSerializers.Storable;
+using HeuristicLab.Common;
+using HeuristicLab.Hive.JobBase;
+using HeuristicLab.Hive.Contracts;
+using HeuristicLab.Hive.Contracts.BusinessObjects;
+
+namespace HeuristicLab.Hive.Contracts {
+  [StorableClass]
+  [Serializable]
+  public class MessageContainerWithJob : MessageContainer {
+
+    [Storable]
+    public SerializedJob SerializedJob { get; set; }
+    
+    public MessageContainerWithJob(MessageType message, Guid parentJobId, SerializedJob serializedJob)
+      : base(message, parentJobId) {
+        this.SerializedJob = serializedJob;
+    }
+
+    public override IDeepCloneable Clone(Cloner cloner) {
+      MessageContainerWithJob clone = (MessageContainerWithJob)base.Clone(cloner);
+      clone.SerializedJob = (SerializedJob)cloner.Clone(this.SerializedJob);
+      return clone;
+    }
+  }
+}
Index: branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Contracts/3.3/ResponseStatus.cs
===================================================================
--- branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Contracts/3.3/ResponseStatus.cs	(revision 4343)
+++ branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Contracts/3.3/ResponseStatus.cs	(revision 4368)
@@ -24,5 +24,5 @@
     RemoveJob_JobDoesNotExist, // ApplicationConstants.RESPONSE_JOB_JOB_DOESNT_EXIST
 
-    GetLastSerializedResult_JobResultNotYetThere, // ApplicationConstants.RESPONSE_JOB_RESULT_NOT_YET_HERE
+    GetSnapshotResult_JobResultNotYetThere, // ApplicationConstants.RESPONSE_JOB_RESULT_NOT_YET_HERE
 
     AbortJob_JobDoesNotExist, // ApplicationConstants.RESPONSE_JOB_JOB_DOESNT_EXIST
Index: branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Contracts/3.3/WcfServicePool.cs
===================================================================
--- branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Contracts/3.3/WcfServicePool.cs	(revision 4368)
+++ branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Contracts/3.3/WcfServicePool.cs	(revision 4368)
@@ -0,0 +1,82 @@
+﻿using System;
+using System.ServiceModel;
+using HeuristicLab.Common;
+
+namespace HeuristicLab.Hive.Contracts {
+  public class WcfServicePool<T> {
+    private static object locker = new object();
+    private string hostAddress;
+    private string username;
+    private string password;
+    private string endpointName;
+    private ChannelFactory<T> factory = null;
+    private Disposable<T> disposableService = null;
+    private int requestCount = 0;
+
+    public WcfServicePool(string hostAddress, string username, string password, string endpointName) {
+      this.hostAddress = hostAddress;
+      this.username = username;
+      this.password = password;
+      this.endpointName = endpointName;
+    }
+
+    private T CreateFacade(string endpointName) {
+      lock (locker) {
+        try {
+          return CreateChannel(endpointName);
+        }
+        catch (EndpointNotFoundException ex) {
+          OnExceptionOccured(ex);
+        }
+        return default(T);
+      }
+    }
+
+    protected virtual T CreateChannel(string endpointName) {
+      if (factory == null) {
+        factory = new ChannelFactory<T>(endpointName);
+        WcfSettings.SetEndpointAddress(factory.Endpoint, hostAddress);
+
+        factory.Credentials.UserName.UserName = username;
+        factory.Credentials.UserName.Password = password;
+      }
+
+      return factory.CreateChannel();
+    }
+
+    public Disposable<T> GetService() {
+      lock (locker) {
+        requestCount++;
+        if (disposableService == null) {
+          disposableService = new Disposable<T>(CreateFacade(endpointName));
+          disposableService.OnDisposing += new EventHandler(disposableService_OnDisposing);
+        }
+        return disposableService;
+      }
+    }
+
+    private void disposableService_OnDisposing(object sender, EventArgs e) {
+      DisposeService();
+    }
+
+    public void DisposeService() {
+      lock (locker) {
+        requestCount--;
+        if (requestCount == 0) {
+          WcfSettings.DisposeWcfClient((ICommunicationObject)disposableService.Obj);
+          disposableService = null;
+        } else if (requestCount < 0) {
+          throw new WcfServicePoolException("requestCount cannot be less than 0.");
+        }
+      }
+    }
+
+    public event EventHandler<EventArgs<Exception>> ExceptionOccured;
+    private void OnExceptionOccured(Exception e) {
+      lock (locker) {
+        var handler = ExceptionOccured;
+        if (handler != null) handler(this, new EventArgs<Exception>(e));
+      }
+    }
+  }
+}
Index: branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Contracts/3.3/WcfServicePoolException.cs
===================================================================
--- branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Contracts/3.3/WcfServicePoolException.cs	(revision 4368)
+++ branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Contracts/3.3/WcfServicePoolException.cs	(revision 4368)
@@ -0,0 +1,7 @@
+﻿using System;
+
+namespace HeuristicLab.Hive.Contracts {
+  public class WcfServicePoolException : Exception {
+    public WcfServicePoolException(string message) : base(message) { }
+  }
+}
Index: branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Contracts/3.3/WcfSettings.cs
===================================================================
--- branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Contracts/3.3/WcfSettings.cs	(revision 4343)
+++ branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Contracts/3.3/WcfSettings.cs	(revision 4368)
@@ -9,4 +9,5 @@
 using System.Net;
 using System.ServiceModel.Description;
+using HeuristicLab.Tracing;
 
 namespace HeuristicLab.Hive.Contracts {
@@ -111,7 +112,7 @@
           catch (CommunicationObjectFaultedException) { obj.Abort(); }
           catch (TimeoutException) { obj.Abort(); }
-          catch (Exception) {
+          catch (Exception e) {
             obj.Abort();
-            throw;
+            Logger.Error(e);
           }
         } else
Index: branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Experiment.Views/3.3/ControlExtensions.cs
===================================================================
--- branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Experiment.Views/3.3/ControlExtensions.cs	(revision 4343)
+++ branches/3.3-Hive/sources/HeuristicLab.Hive/HeuristicLab.Hive.Experiment.Views/3.3/ControlExtensions.cs	(revision 4368)
@@ -3,9 +3,8 @@
 using System.Linq;
 using System.Text;
-using System.Windows.Forms;
 
 namespace HeuristicLab.Hive.Experiment.Views {
   public static class ControlExtensions {
-    public static void InvokeIfRequired(this Control c, Action<Control> action) {
+    public static void InvokeIfRequired(this System.Windows.Forms.Control c, Action<System.Windows.Forms.Control> action) {
       if (c.InvokeRequired) {
         c.Invoke((Action)(() => action(c)));
